//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
  , m_AfterDraw(false)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Chart1->View3D = false;
  Series1->FillSampleValues();
  Chart1->Axes->Left->LabelsFont->Color = clRed;
  Chart1->Axes->Left->Items->Clear();
  for (int i = 0; i < Series1->Count(); i++)
  {
    Chart1->Axes->Left->Items->Add(Series1->YValue[i],"Value"+FloatToStr(Series1->YValue[i]));
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  DoMyGraph(false);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  DoMyGraph(true);
}
//---------------------------------------------------------------------------
void  TForm1::DoMyGraph(bool a_DoAfterDraw)
{
  Chart1->AutoRepaint = false;
  m_AfterDraw = a_DoAfterDraw;
  Series1->Clear();
  Chart1->Axes->Left->LabelsFont->Color = clRed;
  Chart1->Axes->Left->Items->Clear();
  for (int Index = 0; Index < 100; Index++)
  {
    Series1->AddXY(-Index/2, Index);
    Chart1->Axes->Left->Items->Add(Index, FloatToStr(Index));
  }

  Chart1->AutoRepaint = true;
  Chart1->Invalidate();
  Chart1->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Chart1AfterDraw(TObject *Sender)
{
  if (m_AfterDraw)
  {
    m_AfterDraw = false;
    CheckLeftAxisLabels();
    Chart1->AutoRepaint = true;
    Chart1->Invalidate();
    Chart1->Repaint();
  }
}
//---------------------------------------------------------------------------
void TForm1::CheckLeftAxisLabels()
{
  int Size (Chart1->Axes->Left->Items->Count);
  if (Size > 0)
  {
    // Calculate some bounds
    int    HalfLabelHeight (Chart1->Axes->Left->LabelHeight(0.0)/ 2);
    double MinLabelPos (0);
    double MaxLabelPos (100);
    double PosRange (MaxLabelPos - MinLabelPos);
    if (PosRange > 0)
    {
      int    TotalPixels (Chart1->Axes->Left->CalcSizeValue(PosRange));

      // Show the first one
      TAxisItem* pAxisLabel (Chart1->Axes->Left->Items->Item[0]);
      pAxisLabel->Format->Visible = true;

      // Set the initial top
      double LabelPos (pAxisLabel->Value);
      double PixelPos ((LabelPos-MinLabelPos)/PosRange * TotalPixels);
      double LastTop  (PixelPos + HalfLabelHeight);

      // Hide overlapping labels
      for (int Index (1); Index < Size; ++Index)
      {
        // Get the positioning for this label
        pAxisLabel = Chart1->Axes->Left->Items->Item[Index];
        LabelPos  = pAxisLabel->Value;
        PixelPos  = (LabelPos-MinLabelPos)/PosRange * TotalPixels;
        double LabelTop (PixelPos + HalfLabelHeight);
        double LabelBot (PixelPos - HalfLabelHeight);

        // Hide if overlapping
        if (LabelBot > LastTop + 5)
        {
          LastTop = LabelTop;
          pAxisLabel->Format->Visible = true;
        }
        else
        {
          pAxisLabel->Format->Visible = false;
        }
      }
    }
  }
}
//---------------------------------------------------------------------------

